<?php

namespace STM\Match\Result;

use STM\Match\Match;
use STM\Match\Action\MatchAction;
use STM\Match\Stats\Action\StatisticCalculationType;
use STM\StmFactory;

/**
 * Test class for MatchResultCalculator.
 * Generated by PHPUnit on 2013-01-20 at 14:22:10.
 * @group match
 */
class MatchResultCalculatorTest extends \PHPUnit_Framework_TestCase {

    /** @var MatchResultCalculator */
    private $object;
    /** @var Match */
    private $match;
    /** @var MatchAction */
    private $match_actions;

    protected function setUp() {
        $this->object = new MatchResultCalculator();
        $this->match = StmFactory::find()->Match->findById (6);
        if ($this->match) {
            $this->match_actions = StmFactory::find()->MatchPlayerAction->findByMatch($this->match);
        } else {
            $this->match_actions = array();
        }
    }

    public function testCreate_new_match_score() {
        $this->markTestSkipped('Calculates score and saves it to DB. Validation test in MatchResultCalculatorValidatorTest');
    }

    public function testCalculate_score() {
        if (!$this->match) {
            return;
        }
        $this->object->setMatch($this->match);
        foreach (StmFactory::find()->MatchAction->findAll() as $match_action) {
            $this->object->calculateScore($match_action, StatisticCalculationType::SUM);
            parent::assertEquals($this->object->getLastCalculatedScore(), $this->get_score_by_sum($match_action));
            $this->object->calculateScore($match_action, StatisticCalculationType::COUNT);
            parent::assertEquals($this->object->getLastCalculatedScore(), $this->get_score_by_count($match_action));
        }
    }
    
    private function get_score_by_sum($match_action) {
        $score = array('home' => 0, 'away' => 0);
        foreach ($this->match_actions as $action) {
            if ($action->getIdMatchAction() == $match_action->getId()) {
                $team = $this->match->getIdTeamHome() == $action->getIdTeam() ? 'home' : 'away';
                $values = $action->toArray();
                $score[$team] += is_numeric($values['minute_action']) ? (int) $values['minute_action'] : 1;
            }
        }
        return $score;
    }
    
    private function get_score_by_count($match_action) {
        $score = array('home' => 0, 'away' => 0);
        foreach ($this->match_actions as $action) {
            if ($action->getIdMatchAction() == $match_action->getId()) {
                $team = $this->match->getIdTeamHome() == $action->getIdTeam() ? 'home' : 'away';
                $score[$team] += 1;
            }
        }
        return $score;
    }

}

?>